require 'rails/railtie'
require 'planbcd/rails/view_helpers'
require 'planbcd/rails/middleware'

module PlanBCD
  module Rails
    class Railtie < ::Rails::Railtie
      initializer "planbcd-rails:action_view" do |app|
        ActiveSupport.on_load :action_view do
          include ViewHelpers
        end
      end

      initializer "planbcd-rails:middleware" do |app|
        app.middleware.use Middleware
      end
    end
  end
end
